unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, Buttons, FileCtrl;

type
  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    Edit1: TEdit;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    CheckBox1: TCheckBox;
    StringGrid2: TStringGrid;
    procedure Button1Click(Sender: TObject);
    procedure DriveComboBox1Change(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FileListBox1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
  private
    { Private declarations }
  public
    procedure addstr(filename:string;size:string;kind:string;first:boolean);
    procedure addstr2(filename:string;size:string;kind:string;first:boolean);
    { Public declarations }
  end;

var
  Form1: TForm1;
  fi:boolean;
implementation

{$R *.DFM}

procedure TForm1.addstr(filename:string;size:string;kind:string;first:boolean);
begin
  if not first then stringgrid1.RowCount := stringgrid1.RowCount + 1;
  stringgrid1.Cells[0,stringgrid1.RowCount-1] := filename;
  stringgrid1.Cells[1,stringgrid1.RowCount-1] := size;
  stringgrid1.Cells[2,stringgrid1.RowCount-1] := kind;
end;

procedure TForm1.addstr2(filename:string;size:string;kind:string;first:boolean);
begin
  if not first then stringgrid2.RowCount := stringgrid2.RowCount + 1;
  stringgrid2.Cells[0,stringgrid2.RowCount-1] := filename;
  stringgrid2.Cells[1,stringgrid2.RowCount-1] := size;
  stringgrid2.Cells[2,stringgrid2.RowCount-1] := kind;
  fi:=false;
end;

Function scan(Filename:string):string;
var
  f:file of byte;
  b1,b2,b3,b4,b5,b6,b7,b8,b9,b10:byte;
begin
  assignfile(f,filename);
  result:='Unknown';
  try
    reset(f);
    read(f,b1);
    read(f,b2);
    read(f,b3);
    read(f,b4);
    read(f,b5);
    read(f,b6);
    read(f,b7);
    read(f,b8);
    read(f,b9);
    read(f,b10);
    closefile(f);
  except
    result:='Locked or small';
  end;
  if (b1=77) and (b2=84) and (b3=104) then result:='MIDI';
  if (b1=77) and (b2=90) then result:='EXE/DLL';
  if (b1=66) and (b2=77) then result:='BMP';
  if (b1=71) and (b2=73) and (b3=70) then result:='GIF';
  if (b7=74) and (b8=70) and (b9=73) and (b10=70) then result:='JPG';
  if (b1=10) and (b2=5) and (b3=1) and (b4=8) then result:='PCX';
  if (b1=80) and (b2=75) then result:='ZIP';
  if (b1=82) and (b2=73) and (b3=70) and (b4=70) then result:='WAV/ANI';

end;

procedure TForm1.Button1Click(Sender: TObject);
var
  sr: TSearchRec;
  FileAttrs: Integer;
  kind:string;

begin
  StringGrid1.RowCount := 0;
  StringGrid2.RowCount := 0;
  stringgrid1.Rows[0].Clear;
  stringgrid2.Rows[0].Clear;
  fi:=true;
  FileAttrs := faReadOnly + faHidden + faSysFile + faArchive + faAnyFile;

  if FindFirst(Edit1.Text, FileAttrs, sr) = 0 then
  begin
    kind:=scan(extractfilepath(edit1.text)+sr.name);
    addstr(sr.name,IntToStr(sr.Size),kind,true);
    if not(kind='Unknown') then
    addstr2(sr.name,IntToStr(sr.Size),kind,fi);
  end;

  while FindNext(sr) = 0 do
  begin
    kind:=scan(extractfilepath(edit1.text)+sr.name);
    addstr(sr.name,IntToStr(sr.Size),kind,false);
    if not(kind='Unknown') then
    addstr2(sr.name,IntToStr(sr.Size),kind,fi);
  end;
  FindClose(sr);
end;


procedure TForm1.DriveComboBox1Change(Sender: TObject);
begin
  directorylistbox1.Drive := drivecombobox1.Drive;
end;

procedure TForm1.DirectoryListBox1Change(Sender: TObject);
var
  dir,fil,slash:string;
  sr: TSearchRec;
  FileAttrs: Integer;
begin
  slash:='\';
  dir:=extractfilepath(directorylistbox1.Directory);
  fil:=extractfilename(directorylistbox1.Directory);
  if fil='' then slash:='';
  edit1.Text :=dir+fil+slash+'*.*';
  StringGrid1.RowCount := 1;
  StringGrid2.RowCount := 1;
  stringgrid1.Rows[0].Clear;
  stringgrid2.Rows[0].Clear;
  FileAttrs := faReadOnly + faHidden + faSysFile + faArchive + faAnyFile;
  if FindFirst(Edit1.Text, FileAttrs, sr) = 0 then
  begin
    StringGrid1.Cells[0,StringGrid1.RowCount-1] := sr.Name;
    StringGrid1.Cells[1,StringGrid1.RowCount-1] := IntToStr(sr.Size);
    StringGrid1.Cells[2,StringGrid1.RowCount-1] := '';
    StringGrid2.Cells[0,StringGrid2.RowCount-1] := sr.Name;
    StringGrid2.Cells[1,StringGrid2.RowCount-1] := IntToStr(sr.Size);
    StringGrid2.Cells[2,StringGrid2.RowCount-1] := '';
    while FindNext(sr) = 0 do
    begin
      StringGrid1.RowCount := StringGrid1.RowCount + 1;
      StringGrid1.Cells[0, StringGrid1.RowCount-1] := sr.Name;
      StringGrid1.Cells[1, StringGrid1.RowCount-1] := IntToStr(sr.Size);
      StringGrid1.Cells[2,StringGrid1.RowCount-1] := '';
      StringGrid2.RowCount := StringGrid2.RowCount + 1;
      StringGrid2.Cells[0,StringGrid2.RowCount-1] := sr.Name;
      StringGrid2.Cells[1,StringGrid2.RowCount-1] := IntToStr(sr.Size);
      StringGrid2.Cells[2,StringGrid2.RowCount-1] := '';
    end;
    FindClose(sr);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  dir,fil,slash:string;
  sr: TSearchRec;
  FileAttrs: Integer;
begin
  directorylistbox1.Drive := drivecombobox1.Drive;
  DirectoryListBox1Change(Form1);
end;

procedure TForm1.FileListBox1Click(Sender: TObject);
begin
  stringgrid1.SetFocus;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if checkbox1.Checked then
  begin
    stringgrid1.Visible := true;
    stringgrid2.Visible := false;
  end else
  begin
    stringgrid2.Visible := true;
    stringgrid1.Visible := false;
  end;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  close;
end;

end.
